﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDataGenerate.Core
{
    public interface IDDGenService
    {
        #region 参数
        /// <summary>
        /// 前机设备
        /// </summary>
        string Addr0 { get; set; }
        /// <summary>
        /// 后机设备
        /// </summary>
        string Addr1 { get; set; }

        /// <summary>
        /// 前后机距离，单位m
        /// </summary>
        double Distance { get; set; }

        /// <summary>
        /// 最小线速度 2m/min
        /// </summary>
        double MinVelocity { get; set; }

        /// <summary>
        /// 找位置的时间差，不能大于60s
        /// </summary>
        int SecondTolerance { get; set; }
        /// <summary>
        /// 混合数
        /// </summary>
        int Mix { get; set; }

        /// <summary>
        /// 轮询后机数据库周期！！！ 单位min 默认1，最小值0.5
        /// </summary>
        int IntervalMin { get; set; }

        #endregion
        #region 状态
        bool IsError { get;}
        /// <summary>
        /// 错误信息
        /// </summary>
        string ErrMsg { get; }

        /// <summary>
        /// 状态信息
        /// </summary>
        string Msg { get;  }

        /// <summary>
        /// 剩余秒数
        /// </summary>
        int SurplusSec { get; }

        /// <summary>
        /// 最后一条扫描数据Id
        /// </summary>
        long LastScanDataId { get; }

        /// <summary>
        /// 最后一条扫描数据时间
        /// </summary>
        DateTime LastScanDataTime { get; }

        /// <summary>
        /// 运行中
        /// </summary>
        bool IsRunning { get; }
        #endregion

    }
}
