﻿using AutoMapper;
using Misc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDataGenerate.Core.Model
{
    /// <summary>
    /// LC 与 DB 类的映射关系， 会在程序入口处， 手动使用 
    /// var assemblies = System.AppDomain.CurrentDomain.GetAssemblies();
    /// var cfg = new MapperConfigurationExpression();
    /// cfg.AddMaps(assemblies);
    /// Mapper.Initialize(cfg);
    /// 
    /// 枚举全部程序集 中的AutoMapper.Profile 全部加载！！！
    /// </summary>
    public class DiffLcAutoMapperProfile
    {
        public static Mapper Mapper { get; } = new AutoMapper.Mapper(new MapperConfiguration(c =>
        {

            #region LC_ScanData
            c.CreateMap<Lc_DiffData, Db_DiffData>()
            .ForMember(s => s.Datas, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.SerializeObject(s.Datas));
            })
            .ForMember(s => s.Datas0, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.SerializeObject(s.Datas0));
            })
            .ForMember(s => s.Datas1, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.SerializeObject(s.Datas1));
            })
            .ReverseMap()
            .ForMember(s => s.Datas, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.DeserializeObject<double[]>(s.Datas));
            })
            .ForMember(s => s.Datas0, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.DeserializeObject<double[]>(s.Datas0));
            })
            .ForMember(s => s.Datas1, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.DeserializeObject<double[]>(s.Datas1));
            });
            #endregion

            #region LC_BoltmapData
            c.CreateMap<Lc_DiffProfile, Db_DiffProfile>()
            .ForMember(s => s.Map, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.SerializeObject(s.Map));
            })
            .ReverseMap()
            .ForMember(s => s.Map, opt =>
            {
                opt.MapFrom(s => Newtonsoft.Json.JsonConvert.DeserializeObject<Range[]>(s.Map));
            });
            #endregion
        }));


    }
}
